package jx.cn.escort.adapter


import android.content.Context
import android.graphics.Bitmap
import android.graphics.Canvas
import android.graphics.Color
import android.view.*
import android.view.ViewGroup.MarginLayoutParams
import androidx.core.graphics.drawable.toBitmap
import androidx.recyclerview.widget.RecyclerView
import com.google.android.material.divider.MaterialDivider
import com.xuexiang.xui.XUI
import com.xuexiang.xui.utils.DensityUtils
import com.xuexiang.xui.utils.ResUtils
import com.xuexiang.xui.widget.alpha.XUIAlphaTextView
import jx.cn.escort.R
import jx.cn.escort.beans.TaskData
import jx.cn.escort.ui.widget.TaskCardView


open class IndexRecycleAdapter(): RecyclerView.Adapter<IndexRecycleAdapter.IndexRecycleViewHolder>() {


    private var context: Context?=null
    private var mData = mutableListOf<TaskData>()
    constructor(context: Context?):this(){
        this.context=context
    }
    constructor(context: Context?,  source:Collection<TaskData>):this(context){
        if (source.isNotEmpty()) {
            source.forEach{
                mData.add(it)
            }

        }

    }







    class    IndexRecycleViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {
        var item: View?= itemView
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): IndexRecycleViewHolder {
        val view= LayoutInflater.from(context).inflate(R.layout.fragment_tasks_card,parent,false)
        return IndexRecycleViewHolder(view)

    }

    override fun onBindViewHolder(holder: IndexRecycleViewHolder, position: Int) {


            val  cardView= holder.item?.findViewById<TaskCardView>(jx.cn.escort.R.id.card_content)
            val divideTop=  holder.item?.findViewById<MaterialDivider>(jx.cn.escort.R.id.card_divide_top)

            val contextThemeWrapper: ContextThemeWrapper = ContextThemeWrapper(context, jx.cn.escort.R.style.Cus_Theme_AppCompat)
            var     leftText = XUIAlphaTextView(contextThemeWrapper)


            var leftP=ViewGroup.LayoutParams(DensityUtils.px2dp(context,300f),DensityUtils.px2dp(context,120f))  as ViewGroup.LayoutParams
            leftText.layoutParams=leftP


            val layoutPosition = holder.layoutPosition
            leftText.text=mData.get(layoutPosition).name
            leftText.setTextColor(Color.BLACK)
            leftText.setSingleLine()
            var  mLeftImageResource = ResUtils.getDrawable(context, R.drawable.ic_task_title);
            val widthScale = 0.2f
            val heightScale = 0.2f
            var  bitmap=mLeftImageResource.toBitmap()
            mLeftImageResource.setBounds(0, 0,(bitmap.width * widthScale).toInt(), (bitmap.height * heightScale).toInt());

            // 如果你需要将缩放后的BitmapDrawable转换为Bitmap
            val scaledBitmap: Bitmap = Bitmap.createBitmap(mLeftImageResource.bounds.right, mLeftImageResource.bounds.bottom, Bitmap.Config.ARGB_8888)
            val canvas = Canvas(scaledBitmap)
            mLeftImageResource.draw(canvas)


            leftText.setCompoundDrawables(mLeftImageResource, null, null, null);
            leftText.setGravity(Gravity.CENTER_VERTICAL);
            leftText.setPadding(8, 0, 8, 0);
            leftText.setTypeface(XUI.getDefaultTypeface());
            cardView?.setLeftText(leftText)
            cardView?.setDivideTop(divideTop)
            cardView?.addView(leftText)


    }

    override fun getItemCount(): Int {
        return mData.size
    }

}