package jx.cn.escort.ui.activity


import android.content.Context
import android.content.SharedPreferences
import android.content.res.ColorStateList
import android.graphics.Color
import android.os.Bundle
import android.view.ContextThemeWrapper
import android.view.MenuItem
import android.view.View
import android.view.ViewGroup
import android.widget.Toast
import androidx.appcompat.app.AppCompatActivity
import androidx.appcompat.widget.AppCompatTextView
import androidx.fragment.app.Fragment
import androidx.fragment.app.FragmentContainerView
import androidx.fragment.app.FragmentTransaction
import com.google.android.material.bottomnavigation.BottomNavigationView
import com.google.android.material.navigation.NavigationBarView
import com.xuexiang.xui.XUI
import com.xuexiang.xui.widget.actionbar.TitleBar
import jx.cn.escort.R
import jx.cn.escort.databinding.ActivityMainBinding
import jx.cn.escort.extension.ExtensionBinding.Companion.binding
import jx.cn.escort.ui.fragment.BaseNavFragment
import jx.cn.escort.utils.ActivityUtils
import org.koin.core.component.KoinComponent
import org.koin.core.component.inject


class MainActivity : AppCompatActivity(), KoinComponent {

    private val mBinding: ActivityMainBinding by binding<ActivityMainBinding>()

    private val mContext: Context by  inject()

    private val defaultSharedPreferences: SharedPreferences = androidx.preference.PreferenceManager.getDefaultSharedPreferences(mContext)



    override fun onCreate(savedInstanceState: Bundle?) {
        XUI.initTheme(this@MainActivity);
        super.onCreate(savedInstanceState)
        setContentView(mBinding.root)
        var layout= findViewById<View>(R.id.top_bar)
        var topBarView=(layout as ViewGroup).getChildAt(0)  as  TitleBar








        var bottomNav= findViewById<BottomNavigationView>(R.id.bottom_nav)


       var ckColor=Color.parseColor("#8ad1d2")

        var color=Color.parseColor("#5e5656")


        // 设置图标颜色
        val colorStateList = ColorStateList(
            arrayOf(
                intArrayOf(android.R.attr.state_checked),
                intArrayOf(-android.R.attr.state_checked)
            ),
            intArrayOf(ckColor,color) // 这里设置为你想要的颜色
        )
        bottomNav.itemIconTintList = colorStateList

        // 设置文字颜色
        bottomNav.itemTextColor = colorStateList
        bottomNav.isItemActiveIndicatorEnabled=false
        bottomNav.itemBackgroundResource = R.drawable.nav_item_bg


        bottomNav.setOnItemSelectedListener(object: NavigationBarView.OnItemSelectedListener {
            override fun onNavigationItemSelected(item: MenuItem): Boolean {
               var id=item.itemId


                when(id){
                   R.id.index-> {

                       switchFragment(BaseNavFragment(R.layout.fragment_index, context = this@MainActivity),item)


                   }
                    R.id.tasks->{

                        var indexMenu=bottomNav.menu.findItem(R.id.tasks);

                        indexMenu.menuInfo
                        var  fragmentContainerView=findViewById<FragmentContainerView>(R.id.nav_content)
//                       var density=resources.displayMetrics.density
//                       fragmentContainerView.setPadding(
//                           fragmentContainerView.paddingLeft,
//                           (62*density+0.5f).toInt(),  // 设置paddingTop为50dp
//                           fragmentContainerView.paddingRight,
//                           fragmentContainerView.paddingBottom
//                       )
                        fragmentContainerView.requestLayout()

                        switchFragment(BaseNavFragment(R.layout.fragment_tasks, context = this@MainActivity),item)
                    }
                    R.id.mine->{
                        switchFragment(BaseNavFragment(R.layout.fragment_mine,context = this@MainActivity),item)
                    }
                }

                return  true
            }

        })



        bottomNav.setSelectedItemId(R.id.index)



    }



   private fun switchFragment(fragment:Fragment,item: MenuItem){

       var layout= findViewById<View>(R.id.top_bar)
       var topBarView=(layout as ViewGroup).getChildAt(0)  as  TitleBar
       if(item.itemId== R.id.tasks) {

           topBarView.setTitle("${item.title}列表")
       }else{
           topBarView.setTitle(item.title)
       }


        var fm=supportFragmentManager
        var  transaction: FragmentTransaction =fm.beginTransaction()
        transaction.replace(R.id.nav_content,fragment)
         transaction.commitAllowingStateLoss()

    }




}