package jx.cn.escort.ui.widget

import android.animation.ValueAnimator
import android.content.Context
import android.graphics.Canvas
import android.graphics.Color
import android.graphics.Paint
import android.util.AttributeSet
import android.util.TypedValue
import android.view.*
import android.view.animation.DecelerateInterpolator
import android.widget.FrameLayout
import com.google.android.material.bottomappbar.BottomAppBarTopEdgeTreatment
import com.google.android.material.bottomnavigation.BottomNavigationMenuView
import com.google.android.material.bottomnavigation.BottomNavigationView
import com.google.android.material.navigation.NavigationView
import com.google.android.material.shape.MaterialShapeDrawable
import com.google.android.material.shape.ShapePathModel
import jx.cn.escort.R

class CustomBottomNav: BottomNavigationView, NavigationView.OnNavigationItemSelectedListener {



    private val height: Float



    private var selectedItem = 0

    private var selectionAnimator: ValueAnimator? = null



    constructor(context: Context) : this(context, null)
    constructor(context: Context, attrs: AttributeSet?) : this(context, attrs, 0)

    private var bottomNavigationMenuView: View?

    constructor(context: Context, attrs: AttributeSet?, defStyleAttr: Int) : super(context, attrs,
        defStyleAttr) {
        val a = resources.obtainAttributes(attrs, R.styleable.CustomBottomNav)

        val typedValue = TypedValue()
        //context.theme?.resolveAttribute(R.attr.colorPrimary, typedValue, true)
        val backgroundTint = a.getColor(R.styleable.CustomBottomNav_backgroundTint, typedValue.data)

        a.recycle()
        height = dpToPx(56f)



        bottomNavigationMenuView =getChildAt(0)






        val menuParams = bottomNavigationMenuView?.layoutParams as FrameLayout.LayoutParams
        menuParams.gravity = (Gravity.BOTTOM or Gravity.CENTER_HORIZONTAL)



        setWillNotDraw(false)
    }




    override fun onNavigationItemSelected(item: MenuItem): Boolean {
        val indexOfItemSelected = menu.indexOfItem(item)
        if (indexOfItemSelected != selectedItem) {
           // topEdgeTreatment.lastSelectedItem = selectedItem
            //topEdgeTreatment.selectedItem = indexOfItemSelected
            selectedItem = indexOfItemSelected

            selectionAnimator?.end()
            selectionAnimator?.cancel()

            selectionAnimator = ValueAnimator.ofFloat(0f, 1f)
            selectionAnimator?.addUpdateListener {
                //materialShapeDrawable.interpolation = it.animatedValue as Float
            }

            selectionAnimator?.duration = 200
            selectionAnimator?.interpolator = DecelerateInterpolator()

            selectionAnimator?.start()
        }

        return true
    }

    override fun onAttachedToWindow() {
        super.onAttachedToWindow()
        // Change height
    }

    override fun onDraw(canvas: Canvas) {
        super.onDraw(canvas)



    }

    private fun dpToPx(dp: Float): Float {
        return resources.displayMetrics.density * dp
    }

    private fun Menu.indexOfItem(item: MenuItem): Int {
        for (i in 0 until this.size()) {
            val menuItem = menu.getItem(i)
            if (menuItem.itemId == item.itemId) {
                return i
            }
        }
        return -1
    }


}